package com.crm.manager.dao.repository;

import com.crm.rely.backend.core.pojo.table.SysEmailTemplateTable;
import com.crm.rely.backend.dao.repository.BaseRepository;
import org.springframework.data.jpa.repository.Lock;
import org.springframework.stereotype.Repository;

import javax.persistence.LockModeType;
import java.util.List;

@Repository
public interface SysEmailTemplateRepository extends BaseRepository<SysEmailTemplateTable> {

    SysEmailTemplateTable getByCode(String code);

    boolean existsByCode(String code);

    @Lock(LockModeType.PESSIMISTIC_WRITE)
    SysEmailTemplateTable findFirstById(Long id);

    @Lock(LockModeType.PESSIMISTIC_WRITE)
    List<SysEmailTemplateTable> findByIdIn(List<Long> ids);
    @Lock(LockModeType.PESSIMISTIC_WRITE)
    List<SysEmailTemplateTable> findAllByNotificationObject(Integer notificationObject);
}